Subject: Re: bug#52178: 29.0.50; process-environment not used in async-shell-command

From: Damien Merenne <[email-masked]>
Date: Sun, 16 Jan 2022 10:51:58 +0000

But still, the envrc use case for making process-environment buffer
local for some buffer is still valid and I think the original problem
should be fixed.
-- 
Damien MERENNE   <[email-masked]>

Le dim. 16 janv. 2022 à 10:49, Damien Merenne <[email-masked]> a écrit :
>
> Thanks for the reminder and the pointer to the watcher! I finally
> found that it happens due to the `envrc` package.
> That package is meant to set `process-environment` buffer local for
> some buffers. Somehow it sets
> process-environment globally local but only when emacs is started as a
> daemon from the systemd unit. Running
> it normally or with --fg-daemon from a terminal does not set the
> variable globally local. I'll check with the envrc
> maintainer why that would be but there is still something strange
> going on, I would not expect Emacs behaviour to
>  change when started in systemd.
>
> For people stumbling upon this, here is the code I used to pinpoint the problem:
> ```
> (defvar pltraces (list (cons "early-init.el" (local-variable-p
> 'process-environment))))
> (add-hook 'after-load-functions
>           (lambda (fn)
>             (setq pltraces (cons (cons fn (local-variable-p
> 'process-environment)) pltraces))))
> (add-variable-watcher 'process-environment
>                       (lambda (symbol newval operation where)
>                         (when where
>                           (setq pltraces (cons (cons (buffer-name
> where) (local-variable-p 'process-environment)) pltraces)))))
> ```
> It records the place where the variable is set and its local status in
> the `pltraces` variable.
>
> --
> Damien MERENNE   <[email-masked]>
>
> Le sam. 15 janv. 2022 à 21:39, Michael Heerdegen
> <[email-masked]> a écrit :
> >
> > Lars Ingebrigtsen <[email-masked]> writes:
> >
> > > Damien Merenne <[email-masked]> writes:
> > >
> > > > I'll try to find what's triggering it but its not obvious.
> > >
> > > Did you make any progress here?
> >
> > Damien, maybe using a variable watcher:
> >
> >   (info "(elisp) Watching Variables")
> >
> > could help to understand what's going on?  They are able to notice
> > changes in buffer-localness.
> >
> > Michael.